/*+------------------------------------------------------------------+
//| 12:05 PM 4/14/2019                       indicator_utilities.mqh |
//|                             Copyright  2019, WHRoeder@yahoo.com |
//|                                        mailto:WHRoeder@yahoo.com |
//+------------------------------------------------------------------+
//| Buffer support.                                                  |
//| A) Add inputs and buffer definitions (as outlined below.)        |
//| B) Include this file AFTER all buffer #define's (or at end of    |
//|    the main file) to define OnInitBuffers().                     |
//| C) Call OnInitBuffers in OnInit() (See end of file below,) or    |
//|   #define CREATE_ONINIT before the include directive and         |
//|   OnInit() will be defined here for your convenience.            |
//+------------------------------------------------------------------+
//v- Example inputs and buffer definitions --------------------------v
//---- indicator parameters
input ...
#define  CHECK_PARAM1   ...

//---- indicator buffers
#define     SHORTNAME      StringFormat(...)
#define     INDICATOR_DIGITS     ...                     // Defaults to _Digits.
// #property   indicator_type1   DRAW_LINE               // Bug 1090 must set.
// #property   indicator_style1  STYLE_SOLID
// #property   indicator_width1  1
// #property   indicator_label1  "const"
//{ For data window, not shown on chart.
// Prefer this over noChart() so property/color is correct.
#define     NO_CHART    CLR_NONE          // Buffer is not shown on the chart.
#property   indicator_color1        NO_CHART
//} For data window, not shown on chart.
//{ Shown on chart
//{ Shown on chart, not in data window.
#define     INDICATOR_BUFFER1 noData().buf(...)
//} Shown on chart, not in data window.
double      bBuffer[];
#property   indicator_type1   DRAW_LINE                  // Bug 1090 must set.
#property   indicator_color1  Aqua
#define     INDICATOR_BUFFER1 buf(bBuffer)
//} Shown on chart
//{ extra buffers, not shown anywhere.
#define  BUFFERS_COUNT_TOTAL  TBD                                 // Extra
//} extra buffers, not shown anywhere.
#define CREATE_ONINIT
#include <indicator_utilities.mqh>
//^- Example inputs and buffer definitions --------------------------^*/
//+- Start of included code -----------------------------------------+
#include <common_utilities.mqh>  // INDEX/COUNT
enum  Wingding {           WD_THUMBSUP=67,               WD_THUMBSDOWN,
   WD_DOT_LARGE=108,       WD_SQUARE_FILLED_MEDIUM=110,  WD_SQUARE_EMPTY_MEDIUM,
   WD_DIAMOND_SMALL=115,   WD_DIAMOND_LARGE,WD_SQUARE_FILLED_MEDIUM_ROTATED=117,
   WD_SQUARE_FILLED_SMALL_ROTATED=119,                   WD_CIRCLE_EMPTY_0=128,
   WD_CIRCLE_EMPTY_1,      WD_CIRCLE_EMPTY_2,            WD_CIRCLE_EMPTY_3,
   WD_CIRCLE_EMPTY_4,      WD_CIRCLE_EMPTY_5,            WD_CIRCLE_EMPTY_6,
   WD_CIRCLE_EMPTY_7,      WD_CIRCLE_EMPTY_8,            WD_CIRCLE_EMPTY_9,
   WD_CIRCLE_EMPTY_10,     WD_CIRCLE_FILLED_0,           WD_CIRCLE_FILLED_1,
   WD_CIRCLE_FILLED_2,     WD_CIRCLE_FILLED_3,           WD_CIRCLE_FILLED_4,
   WD_CIRCLE_FILLED_5,     WD_CIRCLE_FILLED_6,           WD_CIRCLE_FILLED_7,
   WD_CIRCLE_FILLED_8,     WD_CIRCLE_FILLED_9,           WD_CIRCLE_FILLED_10,
   WD_DOT_SMALL=158,       WD_DOT_MEDIAN,                WD_CIRCLED_DOT=164,
   WD_SQUARE_FILLED_SMALL=167,   WD_STAR_3=169,          WD_STAR_4,
   WD_STAR_5,              WD_STAR_6,                    WD_STAR_5_CIRCLED=181,
   WD_STAR_5_HOLLOW,       WD_ARROW_UP_THIN=225,         WD_ARROW_DN_THIN,
   WD_ARROW_UR_THIN=228,   WD_ARROW_DR_THIN=230,         WD_ARROW_UP_THICK=233,
   WD_ARROW_DN_THICK,      WD_ARROW_UR_THICK=236,        WD_ARROW_DR_THICK=238,
   WD_ARROW_UP_EMPTY=241,  WD_ARROW_DN_EMPTY,            WD_ARROW_UR_EMPTY=246,
   WD_ARROW_DR_EMPTY=248,  WD_SQUARE_EMPTY_SMALL=250,    WD_CROSS_SIGN,
   WD_CHECK_SIGN,          WD_CROSS_SIGN_BOX,            WD_CHECK_SIGN_BOX};
// Predefined in MT5 {DRAW_XXXX}. In Mt4, same value as DRAW_XXXX
enum  ENUM_DRAW_TYPE {  TYPE_LINE,     TYPE_SECTION,     TYPE_HISTOGRAM,
                        TYPE_ARROW,    TYPE_ZIGZAG,      TYPE_NONE=12   };
/* ENUM_LINE_STYLE {    STYLE_SOLID,   STYLE_DASH,       STYLE_DOT,
//                      STYLE_DASHDOT, STYLE_DASHDOTDOT  };
// map BarsBack [3...] to ENUM_LINE_STYLE [0..4] (Solid+3-3+5)%5=Solid
#define LN_STY ENUM_LINE_STYLE((STYLE_SOLID+BarsBack-3+ENUM_LINE_STYLE_COUNT) \
                                                     % ENUM_LINE_STYLE_COUNT)
#define     INDICATOR_BUFFER2 sty(LN_STY)...                                  */
#define     ENUM_LINE_STYLE_COUNT   (STYLE_DASHDOTDOT+1)
class Buffer{
 public:
   void     Buffer(COUNT line) : mIndex(line-1), mType(DRAW_LINE){}     // Ctor
 public:                                                             // Methods
   Buffer*  arr(Wingding ac){ SetIndexArrow(mIndex,ac); return typ(TYPE_ARROW);}
   bool     buf(double& b[])           const{return SetIndexBuffer(mIndex, b)
                                          && ArraySetAsSeries(b,true);  }// MT5
   Buffer*  clr(color c)           /*CONST*/{
                  SetIndexStyle(mIndex, mType, EMPTY, EMPTY, c);  return &this;}
   Buffer*  ev(double ev)          /*CONST*/{
                                 SetIndexEmptyValue(mIndex, ev);  return &this;}
   // #property   indicator_label1  "const"
   Buffer*  lab(string lb)         /*CONST*/{
                                       SetIndexLabel(mIndex, lb); return &this;}
   // Buffer is not shown on the chart. Prefer property indicator_colorX clrNONE
   // over noChart() so indicator properties color shows correct.
   Buffer*  noChart(void)          /*CONST*/{            return clr(clrNONE);  }
   // Buffer is not shown in the data window.
   Buffer*  noData(void)           /*CONST*/{               return lab(NULL);  }
   Buffer*  shf(int s)             /*CONST*/{
                                       SetIndexShift(mIndex, s);  return &this;}
   // #property   indicator_style1  STYLE_SOLID
   Buffer*  sty(ENUM_LINE_STYLE ls)/*CONST*/{
                              SetIndexStyle(mIndex, mType, ls);   return &this;}
   // #property   indicator_type1   DRAW_LINE
   Buffer*  typ(ENUM_DRAW_TYPE dt){ mType = dt; 
                                    SetIndexStyle(mIndex, mType); return &this;}
   // #property   indicator_width1  1
   Buffer*  wid(COUNT w){
                     SetIndexStyle(mIndex, mType, EMPTY, (int)w); return &this;}
 private:                                                            // Data
   INDEX          mIndex;
   ENUM_DRAW_TYPE mType;
}; // Buffer

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInitBuffers(){
   if(IS_DEBUG_MODE) Print("buffers");
   #ifndef INDICATOR_DIGITS
      #define  INDICATOR_DIGITS  _Digits                    // Default is 4
   #endif
   IndicatorDigits(INDICATOR_DIGITS);
#ifdef   SHORTNAME
   IndicatorSetString(INDICATOR_SHORTNAME, SHORTNAME);
#endif
#ifdef   BUFFERS_COUNT_TOTAL
   IndicatorBuffers(BUFFERS_COUNT_TOTAL);
#endif
// Stringize only valid in a macro (build 1090.)
#define  CHECK_PARAM(x) if(!(x)){   alert_id(#x);                             \
                                    return INIT_PARAMETERS_INCORRECT;   }
#ifdef   CHECK_PARAM1
   CHECK_PARAM(CHECK_PARAM1);
#endif
#ifdef   CHECK_PARAM2
   CHECK_PARAM(CHECK_PARAM2);
#endif
#ifdef   CHECK_PARAM3
   CHECK_PARAM(CHECK_PARAM3);
#endif
#ifdef   CHECK_PARAM4
   CHECK_PARAM(CHECK_PARAM4);
#endif
#ifdef   CHECK_PARAM5
   CHECK_PARAM(CHECK_PARAM5);
#endif
#ifdef   CHECK_PARAM6
   CHECK_PARAM(CHECK_PARAM6);
#endif
#ifdef   CHECK_PARAM7
   CHECK_PARAM(CHECK_PARAM7);
#endif
#ifdef   CHECK_PARAM8
   CHECK_PARAM(CHECK_PARAM8);
#endif
#ifdef   CHECK_PARAM9
   CHECK_PARAM(CHECK_PARAM9);
#endif
#ifdef   CHECK_PARAM10
   CHECK_PARAM(CHECK_PARAM10);
#endif
#ifdef   CHECK_PARAM11
   CHECK_PARAM(CHECK_PARAM11);
#endif
#ifdef   CHECK_PARAM12
   CHECK_PARAM(CHECK_PARAM12);
#endif
#ifdef   INDICATOR_BUFFER1
   Buffer B1(1);  if(!B1.INDICATOR_BUFFER1){
      alert_id(StringFormat("B1:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER2
   Buffer B2(2);  if(!B2.INDICATOR_BUFFER2){
      alert_id(StringFormat("B2:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER3
   Buffer B3(3);  if(!B3.INDICATOR_BUFFER3){
      alert_id(StringFormat("B3:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER4
   Buffer B4(4);  if(!B4.INDICATOR_BUFFER4){
      alert_id(StringFormat("B4:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER5
   Buffer B5(5);  if(!B5.INDICATOR_BUFFER5){
      alert_id(StringFormat("B5:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER6
   Buffer B6(6);  if(!B6.INDICATOR_BUFFER6){
      alert_id(StringFormat("B6:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER7
   Buffer B7(7);  if(!B7.INDICATOR_BUFFER7){
      alert_id(StringFormat("B7:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER8
   Buffer B8(8);  if(!B8.INDICATOR_BUFFER8){
      alert_id(StringFormat("B8:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER9
   Buffer B9(9);  if(!B9.INDICATOR_BUFFER9){
      alert_id(StringFormat("B9:%i", _LastError) );      return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER10
   Buffer B10(10);   if(!B10.INDICATOR_BUFFER10){
      alert_id(StringFormat("B10:%i", _LastError) );     return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER11
   Buffer B11(11);   if(!B11.INDICATOR_BUFFER11){
      alert_id(StringFormat("B11:%i", _LastError) );     return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER12
   Buffer B12(12);   if(!B12.INDICATOR_BUFFER12){
      alert_id(StringFormat("B12:%i", _LastError) );     return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER13
   Buffer B13(13);   if(!B13.INDICATOR_BUFFER13){
      alert_id(StringFormat("B13:%i", _LastError) );     return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER14
   Buffer B14(14);   if(!B14.INDICATOR_BUFFER14){
      alert_id(StringFormat("B14:%i", _LastError) );     return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_BUFFER15
   Buffer B15(15);   if(!B15.INDICATOR_BUFFER15){
      alert_id(StringFormat("B15:%i", _LastError) );     return INIT_FAILED;  }
#endif
#ifdef   INDICATOR_LEVEL1
   SetLevelValue(0, INDICATOR_LEVEL1);
   #ifdef   INDICATOR_LEVEL2
      SetLevelValue(1, INDICATOR_LEVEL2);
      #ifdef   INDICATOR_LEVEL3
         SetLevelValue(2, INDICATOR_LEVEL3);
         #ifdef   INDICATOR_LEVEL4
            SetLevelValue(3, INDICATOR_LEVEL4);
            #ifdef   INDICATOR_LEVEL5
               SetLevelValue(4, INDICATOR_LEVEL5);
               #ifdef   INDICATOR_LEVEL6
                  SetLevelValue(5, INDICATOR_LEVEL6);
                  #ifdef   INDICATOR_LEVEL7
                     SetLevelValue(6, INDICATOR_LEVEL7);
                     #ifdef   INDICATOR_LEVEL8
                        SetLevelValue(7, INDICATOR_LEVEL8);
                     #endif
                  #endif
               #endif
            #endif
         #endif
      #endif
   #endif
#endif
   if(IS_DEBUG_MODE) Print("init ok");
//---
   return INIT_SUCCEEDED;
}
#ifdef CREATE_ONINIT
int      OnInit(){   return OnInitBuffers(); }
#endif
//+- indicator_utilities.mqh ----------------------------------------+
